﻿package  
{
	import org.flixel.*;
	/**
	 * ...
	 * @author mattdev
	 */
	public class Laser extends FlxSprite
	{
		protected static const LASER_SPEED:int = 600;
		
		[Embed(source="../assets/textures/laser.png")] 
		protected var laserImage:Class;
		
		protected var ownerPlayer: Player;
		protected var bouncePosition: FlxPoint = new FlxPoint();
		protected var startPosition: FlxPoint = new FlxPoint();
		
		protected var lifetime: Number;
		
		public function Laser(player:Player, angle: int)
		{
			
			ownerPlayer = player;

			super();
			loadGraphic(laserImage);

			this.x = player.getMidpoint().x;
			this.y = player.getMidpoint().y;

			velocity.x = Math.cos((angle+90) * (Math.PI / 180.0)) * LASER_SPEED;
			velocity.y = Math.sin((angle + 90) * (Math.PI / 180.0)) * LASER_SPEED;
			this.angle = angle;
			
			this.x += velocity.x * 0.03;
			this.y += velocity.y * 0.03;
			
			var playState:PlayState = FlxG.state as PlayState;
			
			startPosition = this.getMidpoint();
			var rayEnd:FlxPoint = new FlxPoint(this.getMidpoint().x + velocity.x * 100.0, this.getMidpoint().x + velocity.y * 100.0);
			playState.world.levelLayer.ray(startPosition, rayEnd, bouncePosition);
			
			playState.bulletsGroup.add(this);
				
		}
		
		public override function destroy(): void
		{
			super.destroy();
			
			var playState:PlayState = FlxG.state as PlayState;
			playState.bulletsGroup.remove(this, true);
		}
		
		
		public override function update():void
		{
			lifetime += FlxG.elapsed;
		
			super.update();

			var playState:PlayState = FlxG.state as PlayState;
			if ( FlxU.getDistance(startPosition, this.getMidpoint()) + LASER_SPEED * 0.01 >= FlxU.getDistance(startPosition, bouncePosition) )
			{
				this.destroy();
			}
			
			if ( lifetime >= 5.0 )
			{
				this.destroy();
			}
			
		}
	}

}