﻿package  
{	
	import org.flixel.*;
 
	/**
	 * ...
	 * @author mattdev
	 */
	public class MiniMap
	{
		public var groundLayer:FlxTilemap;
		public var roadLayer:FlxTilemap;
		public var levelLayer:FlxTilemap;

		[Embed(source="../assets/textures/ground_mm.png")] 
		protected var groundImage:Class;
		
		[Embed(source="../assets/textures/roads_mm.png")] 
		protected var roadImage:Class;
		
		[Embed(source="../assets/textures/tiles_mm.png")] 
		protected var tilesImage:Class;
				
		public var bgSprite: FlxSprite;
		
		public var mmEntities: Array;
		
		
		public function MiniMap(world:World, x:int, y:int) 
		{
			mmEntities = new Array();
			
			bgSprite = new FlxSprite(x - 1, y - 1);
			bgSprite.makeGraphic(world.mapWidth + 2, world.mapWidth + 2, 0xffa0a0a0);
			bgSprite.scrollFactor.x = bgSprite.scrollFactor.y = 0.0;
			
			groundLayer = new FlxTilemap();
			groundLayer.loadMap(FlxTilemap.arrayToCSV(world.groundData, world.mapWidth), groundImage, 1, 1, FlxTilemap.OFF, 0, 0);

			roadLayer = new FlxTilemap();
			roadLayer.loadMap(FlxTilemap.arrayToCSV(world.roadData, world.mapWidth), roadImage, 1, 1, FlxTilemap.OFF, 0, 0);
			
			levelLayer = new FlxTilemap();
			levelLayer.loadMap(FlxTilemap.arrayToCSV(world.levelData, world.mapWidth), tilesImage, 1, 1, FlxTilemap.OFF, 0, 0);
			
			levelLayer.scrollFactor.x = levelLayer.scrollFactor.y = 0.0; 
			roadLayer.scrollFactor.x = roadLayer.scrollFactor.y = 0.0;
			groundLayer.scrollFactor.x = groundLayer.scrollFactor.y = 0.0;
			
			levelLayer.x = x;
			roadLayer.x = x;
			groundLayer.x = x;
			
			levelLayer.y = y;
			roadLayer.y = y;
			groundLayer.y = y;

			var playState:PlayState = FlxG.state as PlayState;
			
			playState.uiGroup.add(bgSprite);
			playState.uiGroup.add(groundLayer);
			playState.uiGroup.add(roadLayer);
			playState.uiGroup.add(levelLayer);
		}
		
		public function addSprite(sprite:FlxSprite, color:uint, size:uint): void
		{
			var playState:PlayState = FlxG.state as PlayState;
			
			var mmSprite: FlxSprite = new FlxSprite();
			mmSprite.scrollFactor.x = mmSprite.scrollFactor.y = 0.0;
			mmSprite.makeGraphic(size, size, color);
			
			playState.uiGroup.add(mmSprite);
			mmEntities.push(new Array(mmSprite,sprite));
		}
		
		
		public function removeSprite(sprite:FlxSprite): void
		{
			var playState:PlayState = FlxG.state as PlayState;
			for ( var i:int = 0; i < mmEntities.length; i++ )
			{
				var ar:Array = mmEntities[i];
				
				if ( ar[1] == sprite )
				{
					playState.uiGroup.remove(ar[0]);
					mmEntities.splice(i, 1);
					return;
				}
			}			
		}
		
		public function update(): void
		{
			
			for ( var i:int = 0; i < mmEntities.length; i++ )
			{
				var ar:Array = mmEntities[i];
				ar[0].x = levelLayer.x + ar[1].x / 16.0;
				ar[0].y = levelLayer.y + ar[1].y / 16.0;
			}
		}
		
	}

}