﻿package  
{
	import org.flixel.*;
	/**
	 * ...
	 * @author mattdev
	 */
	public class Player extends FlxSprite
	{
		protected static const PLAYER_RUN_SPEED:int = 100;
		
		public var gun: Gun;
		public var food: Number;
		
		[Embed(source="../assets/textures/player_legs.png")] 
		protected var playerImage:Class;
		
		public function Player() 
		{
			super();
			
			loadGraphic(playerImage, true);
			
			addAnimation("run", [0, 1, 2, 3, 2, 1], 10);
			addAnimation("idle", [4, 5], 2);
			this.play("idle");
			
			addToMinimap();
		}
		
		public function init(): void
		{
			gun = new Gun(this);
			var playState:PlayState = FlxG.state as PlayState;
			playState.defaultGroup.add(gun);
			food = 1.0;
			

		}
		
		public function addToMinimap(): void
		{
			var playState:PlayState = FlxG.state as PlayState;
			playState.miniMap.addSprite(this, 0xff0000ff, 2);
		}
		
		public function modifyHealth(delta:Number): void
		{
			var playState:PlayState = FlxG.state as PlayState;
			if ( playState.level == 1 )
				delta *= 0.3;
				
			this.health += delta;

			playState.healthBar.setProgress(health);

			if ( this.health < 0.0 )
			{
				this.health = 0.0;
				
				FlxG.switchState(new DeathState(playState.level));
				
			}	
		}
		
		public function modifyFood(delta:Number): void
		{
			this.food += delta;
			
			if ( this.food < 0.0 )
			{
				this.food = 0.0;
			}
			
			if ( this.food > 1.0 )
			{
				this.food = 1.0;
			}
			var playState:PlayState = FlxG.state as PlayState;
			playState.foodBar.setProgress(food);
		}

		public override function update():void
		{
			velocity.x = 0.0;
			velocity.y = 0.0;
			
			
			if (FlxG.keys.LEFT || FlxG.keys.A)
			{
				facing = LEFT;
				velocity.x = -PLAYER_RUN_SPEED;
				play("run");
			}
			if (FlxG.keys.RIGHT || FlxG.keys.D)
			{
				facing = RIGHT;
				velocity.x = PLAYER_RUN_SPEED;
				play("run");
			}
			if (FlxG.keys.UP || FlxG.keys.W)
			{
				facing = UP;
				velocity.y = -PLAYER_RUN_SPEED;
				play("run");
			}
			if (FlxG.keys.DOWN || FlxG.keys.S)
			{
				facing = DOWN;
				velocity.y = PLAYER_RUN_SPEED;
				play("run");
			}
			
			if( velocity.x == 0.0 && velocity.y == 0.0 )
			{
				play("idle");
			}
			else
			{
				angle = FlxU.getAngle(new FlxPoint(0, 0), velocity);
			}
			
			this.modifyFood( -0.02 * FlxG.elapsed );
			if ( this.food <= 0.0 )
			{
				this.modifyHealth( -0.06 * FlxG.elapsed );
			}
			
			super.update();
			
		}
	}

}