﻿package  
{
	import org.flixel.*;
	/**
	 * ...
	 * @author mattdev
	 */
	public class StatusBar
	{
		private var bar:FlxSprite;
		private var inside:FlxSprite;
		private var frame:FlxSprite;
		private var shadow:FlxSprite;
		
		private var width: int;
		
		
		public function StatusBar(playState:PlayState, x:int, y:int, barWidth:int, barHeight:int, color:uint)
		{
			width = barWidth;
			
			shadow = new FlxSprite(0, 0);
			shadow.makeGraphic(width+2,barHeight,0xa0a0a0a0); //White frame for the health bar
			shadow.scrollFactor.x = shadow.scrollFactor.y = 0;
			playState.uiGroup.add(shadow);
			
			frame = new FlxSprite(0, 0);
			frame.makeGraphic(width+2,barHeight); //White frame for the health bar
			frame.scrollFactor.x = frame.scrollFactor.y = 0;
			playState.uiGroup.add(frame);			
			 
			inside = new FlxSprite(1, 1);
			inside.makeGraphic(width,barHeight-2,0xff000000); //Black interior, 48 pixels wide
			inside.scrollFactor.x = inside.scrollFactor.y = 0;
			playState.uiGroup.add(inside);
			 
			bar = new FlxSprite(1, 1);
			bar.makeGraphic(1,barHeight-2,color); //The red bar itself
			bar.scrollFactor.x = bar.scrollFactor.y = 0;
			bar.origin.x = bar.origin.y = 0; //Zero out the origin
			bar.scale.x = width; //Fill up the health bar all the way
			playState.uiGroup.add(bar);
			 
			bar.scale.x = width; //Drop the health bar to half
			
			shadow.x = x + 1;
			shadow.y = y + 1;
			frame.x = x + 0;
			frame.y = y + 0;
			inside.x = x + 1;
			inside.y = y + 1;
			bar.x = x + 1;
			bar.y = y + 1;
		}
		
		public function setProgress(progress:Number): void
		{
			bar.scale.x = width * progress; //Drop the health bar to half
		}
		
	}

}